/* AbiSource Program Utilities
 * Copyright (C) 1998 AbiSource, Inc.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA.
 */
 


#ifndef PS_FONTMAP_H
#define PS_FONTMAP_H

#include <stdio.h>
#include "ut_hash.h"

class ps_Fontmap
{
public:
	ps_Fontmap();
	~ps_Fontmap();
	
	UT_Bool	mapFontName(const char * szFamily, const char * szFace, 
						const char * szStyle, const char * szWeight,
						char * pBuffer, UT_uint32 bufferLength);

	UT_Bool createFontHash();

private:
	UT_HashTable *	m_pFontHash;
	UT_HashTable *	m_pAliasHash;
	UT_HashTable *	m_pCSSHash;
	UT_Bool parseFontmap();
	UT_Bool addCSSAliases();
};

#endif /* PS_FONTMAP_H */

